// ******************* START OF CLASSIC.H *******************
//
// Copyright (c) 1998 Mark R. Nelson. All Rights Reserved.
//
// This header file has all of the definitions and prototypes
// needed to use the ClassicHandler class.


#ifndef _CLASSIC_DOT_H
#define _CLASSIC_DOT_H

#include "rs232.h"
#include "pc8250.h"

struct classic_data {
    int status_register;
    struct isr_data_block *data_pointers[ 8 ];
};

class ClassicHandler : public Handler {
    private :
        struct classic_data isr_info;
        irq_name irq;
        RS232Error connected;
    public :
        ClassicHandler( irq_name irq_line,
                        int status_register_address );
        ~ClassicHandler( void );
        virtual RS232Error AddPort( RS232PortName port_name,
                                    struct isr_data_block *data );
        virtual void DeletePort( RS232PortName port_name );
};

#endif // #ifndef _CLASSIC_DOT_H

// ********************* END OF CLASSIC.H ********************

