//
//  Tapi32Port.h
//
//  Source code from:
//
//  Serial Communications: A C++ Developer's Guide, 2nd 
//  Edition by Mark Nelson, IDG Books, 1999
//
//  Please see the book for information on usage.
//
// This file contains the declaration for class Tapi32Port,.
// This class is derived from Win32Port, and it uses nearly
// every bit of code from the base class, with one notable
// exception. The normal constructor for Win32Port expects
// to open a port by name. When we are using TAPI, we don't
// get to open the port by name. Instead, TAPI gets the port
// all set up and ready to use, then hands us a handle to
// the port. Tapi32Port() has an alternative constrcutor that
// takes that handle and inserts it into the Win32 object,
// without trying to open a port with a call to CreateFile(),
// which is inapporpriate for TAPI.
//

#ifndef _TAPI32_PORT_H
#define _TAPI32_PORT_H

#include "Win32Port.h"

class Tapi32Port : public Win32Port
{
public :
    Tapi32Port( HANDLE h );

};

#endif // #ifndef _TAPI32_PORT_H

